# -*- coding: utf-8 -*-

#2a) Si faccia il seguente esperimento concettuale: data una catena peptidica 
# formata da R residui, se ne considerino R copie; si spezzi la prima copia 
# in due frammenti, tagliando subito prima del primo residuo (ottenendo un 
# frammento di lunghezza 0 e uno di lunghezza R); si spezzi la seconda copia 
# tagliando subito prima del secondo residuo (lunghezze: 1 e R-1), e così via. 
# Per ogni copia frammentata, si può scrivere una lista con i pesi del primo e 
# del secondo frammento: il peso di un polipeptide si ottenga come la somma 
# dei pesi dei residui che lo compongono. 
# Date tutte le copie ORDINATE, si può scrivere una lista lunga R 
# (che chiameremo "frag list") il cui elemento i-esimo contiene la lista dei 
# pesi dei due frammenti della i-esima copia.
# Si scriva la funzione fr2prot(frlist) che, data una frag list in input, 
# restituisca la sequenza proteica da cui deriva.
#
# Es:
# frl=[[0, 389.1587], [163.06333, 226.09537], [292.10593, 97.05277]]
# fr2prot(frl) --> "YEP"


from uso1 import buildMIMass
import math

mimasses=buildMIMass() #a dictionary with residue/mass entries    

def closestAmm(w, toler=0.001):
    "returns the amino acid (residue) whose mass is close to the input, with given tolerance"
    if (w<(mimasses['G']-toler)) or (w>(mimasses['W']+toler)):
        return None
    for a,aw in mimasses.iteritems():
        if math.fabs(w-aw)<toler:
            return a
    return None


def fr2prot(brlist):
    ordlist=[e[0] for e in brlist]
    ordlist.append(brlist[0][1])
    return "".join(closestAmm(w2-w1) for w2,w1 in zip(ordlist[1:],ordlist[:-1]))
