# -*- coding: utf-8 -*-

#3a) Un grafo diretto si può rappresentare con la cosiddetta "matrice di 
# adiacenza" A; la casella  A[i][j] contiene la label presente sull'arco dal 
# vertice i al vertice j, se l'arco è presente, oppure un valore speciale 
# (0, None, ecc.) se l'arco non c'è.
# Supponiamo, come indicato al punto 2a), di considerare tutti i frammenti 
# ottenibili da una catena peptidica P dividendola in due con un taglio fatto 
# in ogni posizione possibile (compreso dunque il frammento di lunghezza nulla, 
# e quello corrispondente all'intera catena). Si possono ottenere poi i pesi 
# di ciascun frammento, posizionandoli in una lista ordinata che chiameremo 
# "ufrag list". Indichiamo con w(i) il peso di indice i-esimo.
# Data una "ufrag list", si può costruire il relativo "grafo spettrale" 
# associando un vertice a ciascun elemento nell' ufrag list, e inserendo un 
# arco da i a j se w(j)-w(i) corrisponde al peso di un residuo; la label 
# dell'arco dovrà essere il simbolo di tale residuo. 
# Si scriva la funzione build_madjac(ufr) che restituisca la matrice di 
# adiacenza del grafo spettrale della "ufrag list" data in input.
# La matrice dovrà essere implementata con una lista di liste, i cui elementi 
# siano caratteri. Per indicare l'assenza di archi, si usi il carattere ".".
#
# Es:  xlist=[0.0, 97.05277, 163.06333, 226.09537, 292.10593, 389.1587]
#      build_madjac(xlist) --> (v. la rappresentazione sotto:)
#
#       . P Y . . .
#       . . . E . .
#       . . . . E .
#       . . . . . Y
#       . . . . . P
#       . . . . . .


from soluzione2 import closestAmm

def build_madjac(ufr):
    l=len(ufr)
    A=[]
    for i in xrange(l):
        row=[]
        for j in xrange(l):
            if j>i:
                label=closestAmm(ufr[j]-ufr[i])
                if label is None:
                    label="."
            else:
                label="."
            row.append(label)
        A.append(row)
    return A
