# -*- coding: utf-8 -*-

#4a) Un grafo diretto può essere rappresentato da una "lista di adiacenza": 
# i vertici vengono ordinati, in modo che ciascuno corrisponda a un indice; per 
# ogni vertice, si mantiene una lista degli indici dei vertici "vicini" da esso 
# raggiungibili con un solo passo. Se gli archi hanno una label, al posto 
# del solo indice del vertice di destinazione possiamo inserire una tupla 
# contenente l'indice del vertice e la label dell'arco.
# Es: un grafo con 3 nodi e 2 archi - dal primo al secondo nodo (label: "a") e 
# dal primo al terzo (label: "b") - è rappresentato dalla lista di adiacenza:
# [[(1,"a"),(2,"b")],[],[]]
# Si consideri il grafo spettrale di una sequenza proteica P, così come 
# definito al punto 3a). Si scriva una funzione build_spectr(pseq) che, data 
# una sequenza proteica, ne calcoli il grafo spettrale restituendolo sotto
# forma di lista di adiacenza. Si intende che i vertici vengano considerati in 
# ordine crescente di peso, e che la lista dei vicini per ciascun vertice sia 
# ordinata per indici di vertice crescenti.


from soluzione2 import mimasses, closestAmm

def buildspectr(pseq):
    mseq=[mimasses[x] for x in pseq] 
    vertices=[]
    for i in xrange(0,len(pseq)):
        vertices.append(sum(mseq[:i]))
        vertices.append(sum(mseq[i:]))   
    vertices.sort()
    l=len(vertices)
    ladj=[]
    for i in xrange(l):
        neighbors=[]
        for j in xrange(l):
            if j>i:
                label=closestAmm(vertices[j]-vertices[i])
                if label is not None:
                    neighbors.append((j,label))    
        ladj.append(neighbors)
    return ladj   
    